/*
 * THIS FILE IS AUTOMATICALLY GENERATED
 *
 * I2C-Generator: 0.3.0
 * Yaml Version: 0.1.0
 * Template Version: 0.7.0-62-g3d691f9
 */
/*
 * Copyright (c) 2021, Sensirion AG
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * * Neither the name of Sensirion AG nor the names of its
 *   contributors may be used to endorse or promote products derived from
 *   this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef SENSIRIONI2CSGP40_H
#define SENSIRIONI2CSGP40_H

#include <Wire.h>

#include <SensirionCore.h>

class SensirionI2CSgp40 {

  public:
    SensirionI2CSgp40();
    /**
     * begin() - Initializes the SensirionI2CSgp40 class.
     *
     * @param serial Arduino stream object to be communicated with.
     *
     */
    void begin(TwoWire& i2cBus);

    /**
     * measureRawSignal() - This command starts/continues the VOC measurement
     * mode
     *
     * @param relativeHumidity Leaves humidity compensation disabled by sending
     * the default value 0x8000 (50%RH) or enables humidity compensation when
     * sending the relative humidity in ticks (ticks = %RH * 65535 / 100)
     *
     * @param temperature Leaves humidity compensation disabled by sending the
     * default value 0x6666 (25 degC) or enables humidity compensation when
     * sending the temperature in ticks (ticks = (degC + 45) * 65535 / 175)
     *
     * @param srawVoc u16 unsigned integer directly provides the raw signal
     * SRAW_VOC in ticks which is proportional to the logarithm of the
     * resistance of the sensing element.
     *
     * @return 0 on success, an error code otherwise
     */
    uint16_t measureRawSignal(uint16_t relativeHumidity, uint16_t temperature,
                              uint16_t& srawVoc);

    /**
     * executeSelfTest() - This command triggers the built-in self-test checking
     * for integrity of the hotplate and MOX material and returns the result of
     * this test as 2 bytes
     *
     * @param testResult 0xD4 00: all tests passed successfully or 0x4B 00: one
     * or more tests have failed
     *
     * @return 0 on success, an error code otherwise
     */
    uint16_t executeSelfTest(uint16_t& testResult);

    /**
     * turnHeaterOff() - This command turns the hotplate off and stops the
     * measurement. Subsequently, the sensor enters the idle mode.
     *
     * @return 0 on success, an error code otherwise
     */
    uint16_t turnHeaterOff(void);

    /**
     * getSerialNumber() - This command provides the decimal serial number of
     * the SGP40 chip by returning 3x2 bytes.
     *
     * @param serialNumber 48-bit unique serial number
     *
     * @return 0 on success, an error code otherwise
     */
    uint16_t getSerialNumber(uint16_t serialNumber[], uint8_t serialNumberSize);

  private:
    TwoWire* _i2cBus = nullptr;
};

#endif /* SENSIRIONI2CSGP40_H */
